<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="UTF-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>Document</title>
  </head>
  <body>
    <img id="qr-code" />
  </body>
  <script type="module">
    const vCardData = `
BEGIN:VCARD
VERSION:3.0
N:Paulino;Crystal;
FN:Crystal Paulino
ORG:Pioneer Founds;
TITLE:Asistente Administrativa
ADR;TYPE=WORK,PREF:;;Erick Leonard Ekman Esq., Camino Chiquito, Plaza Patio del Norte, Local 304, Arroyo Hondo, Santo Domingo, República Dominicana;
TEL;TYPE=PREF,VOICE:(809) 549 3797 
TEL;TYPE=PREF,CELL: 829-520-1603
EMAIL;TYPE=PREF,INTERNET:c.paulino@pioneerfunds.do
URL:https://www.pioneerfunds.do/
END:VCARD
`;

    import QRCode from "https://cdn.skypack.dev/qrcode";
    import jsPDF from "https://cdn.skypack.dev/jspdf";

    // Function to generate QR code
    async function generateQRCode(data) {
      try {
        const qrCodeUrl = await QRCode.toDataURL(vCardData);
        return qrCodeUrl;
      } catch (error) {
        console.error(error);
      }
    }
    const url = await generateQRCode(vCardData);

    const doc = new jsPDF({
      orientation: "p",
      unit: "mm",
      format: "a4",
      putOnlyUsedFonts: true,
      border: false,
    });

    // Calculate positions to center the QR code on the A4 page
    const pageWidth = doc.internal.pageSize.getWidth();
    const pageHeight = doc.internal.pageSize.getHeight();
    const qrCodeWidth = pageWidth; // Width of the QR code in mm
    const qrCodeHeight = pageWidth; // Height of the QR code in mm
    const xPosition = pageWidth / 2 - qrCodeWidth / 2;
    const yPosition = pageHeight / 2 - qrCodeHeight / 2;

    doc.addImage(url, "PNG", xPosition, yPosition, qrCodeWidth, qrCodeHeight);
    doc.save("qrcode.pdf");

    const image = document.querySelector("#qr-code");

    image.src = url;
  </script>
</html>
